#ifndef EXECUTOR_H_
#define EXECUTOR_H_

#include <string>
#include <map>

#include "antlr4-runtime.h"
#include "Pcl5BaseVisitor.h"

#include "../Object.h"

namespace backend { namespace interpreter {

using namespace std;

typedef antlrcpp::Any Object;

class Executor : public Pcl5BaseVisitor
{
public:
    Executor() {}
    virtual ~Executor() {}

    Object visitProgram(Pcl5Parser::ProgramContext *ctx) override;
    Object visitStatement(Pcl5Parser::StatementContext *ctx) override;
    Object visitStatementList(Pcl5Parser::StatementListContext *ctx) override;
    Object visitCompoundStatement(Pcl5Parser::CompoundStatementContext *ctx) override;
    Object visitAssignmentStatement(Pcl5Parser::AssignmentStatementContext *ctx) override;
    Object visitRepeatStatement(Pcl5Parser::RepeatStatementContext *ctx) override;
    Object visitWriteStatement(Pcl5Parser::WriteStatementContext *ctx) override;
    Object visitWritelnStatement(Pcl5Parser::WritelnStatementContext *ctx) override;
    Object visitExpression(Pcl5Parser::ExpressionContext *ctx) override;
    Object visitVariable(Pcl5Parser::VariableContext *ctx) override;
    Object visitNumber(Pcl5Parser::NumberContext *ctx) override;

    // Complete this class!

};

}}  // namespace backend::interpreter

#endif /* EXECUTOR_H_ */
